define("io.ox/office/editframework/app/editapplication",["exports","io.ox/core/tk/doc-converter-utils","io.ox/core/api/user","io.ox/core/api/tab","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/forms","io.ox/office/tk/utils/io","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/tk/worker/intervalrunner","io.ox/office/tk/dialogs","io.ox/office/baseframework/utils/apputils","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/baseframework/utils/errorcontextdata","io.ox/office/baseframework/utils/clienterror","io.ox/office/baseframework/utils/infostate","io.ox/office/baseframework/utils/errormessages","io.ox/office/baseframework/utils/infomessages","io.ox/office/baseframework/utils/seleniumlogger","io.ox/office/baseframework/app/baseapplication","io.ox/office/baseframework/app/extensionregistry","io.ox/office/rt2/rt2const","io.ox/office/rt2/rt2protocol","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/utils/webfonts","io.ox/office/editframework/utils/dateutils","io.ox/office/editframework/app/rtconnection","io.ox/office/editframework/app/rtconnectionviewer","io.ox/office/editframework/app/acquireeditrightsworker","io.ox/office/editframework/view/editlabels","gettext!io.ox/office/editframework/main"],function(e,Jt,Xt,en,tn,t,n,nn,r,i,rn,on,o,a,s,an,sn,ln,cn,dn,un,gn,pn,l,fn,En,hn,On,_n,c,d,Sn,mn,In,u,Nn,Rn){"use strict";var An=t.isFiniteNumber,Dn=t.getNumber,vn=t.getArray,g=t.newPromise,yn=t.newFulfilled,Cn=t.newRejected,bn=t.toPromise,Tn=n.stringEndsWith,wn=n.trimAndCleanString,Fn=n.capitalizeFirst,Ln=n.filterArray,Un=r.FILTER_MODULE_NAME,xn=r.requireOptModule,kn=i.globalLogger,$n=i.getLogBuffer,Pn=On.SaveAsType,Mn=On.STORAGE_AVAILABLE,Bn=On.RENAME_DISABLED,Hn=On.TRANSFER_EDIT_RIGHTS_TIMEOUT,Gn=On.getStorageValue,qn=o.IntervalRunner,jn=a.MessageDialog,Vn=s.FlushReason,Wn=s.QuitReason,Yn=s.createTextDownload,zn=l.BaseApplication,Kn=c.otLogger,Qn=c.dbgDumpActions,Zn=d.importWebFonts,Jn=u.acquireEditLogger,Xn=u.AcquireEditRightsWorker,er="accept",tr="decline",nr="inactive",rr=_.noI18n.fix(Rn("unnamed")),ir=["editUserId","editUser","hasErrors","writeProtected","activeUsers","locked","lockedByUser","lockedByUserId","failSafeSaveDone","serverOSN"];function or(e){e=vn(e,"operations",!0);return e.every(_.isObject)?e:(kn.error("$badge{EditApp} getOperationsFromData: invalid elements in operations array",e),[])}function ar(e){if(_.isObject(e)&&_.isString(e.action))switch(e.action){case"reload":e.action={itemKey:"document/reload",icon:Nn.RELOAD_ICON,label:Nn.RELOAD_LABEL};break;case"acquireedit":e.action={itemKey:"document/acquireeditOrPending",icon:Nn.EDIT_ICON,label:Nn.EDIT_LABEL};break;case"loadrestored":e.action={itemKey:"document/reload",icon:Nn.LOAD_RESTORED_ICON,label:Nn.LOAD_RESTORED_LABEL};break;default:delete e.action}}function sr(r,i,o){return g(function(e,t){r.done(e).fail(t);var n=window.setTimeout(function(){t("timeout"),kn.warn(o+" - operation timed out")},i);r.always(function(){window.clearTimeout(n)})})}e.EditApplication=zn.extend(function(e,T,w){var F=this,L=null,U=null,t=null,x=null,n=null,k=null,P=null,u=[],i=null,r=!1,o=!1,a=0,M=tn.getFunctionOption(w,"preProcessHandler"),B=tn.getFunctionOption(w,"postProcessHandler"),c=tn.getFunctionOption(w,"fastEmptyLoadHandler"),g=tn.getFunctionOption(w,"previewHandler"),s=tn.getFunctionOption(w,"importFailedHandler",_.noop),l=tn.getFunctionOption(w,"optimizeOperationsHandler"),d=!0,p=tn.getFunctionOption(w,"mergeCachedOperationsHandler"),f=!w||!w.otConfigKey||On.getFlag(w.otConfigKey,!0),E=f?100:tn.getNumberOption(w,"sendActionsDelay",0),h=tn.getBooleanOption(w,"isMultiSelectionApp",!0),O=tn.getBooleanOption(w,"isSnapshotApp",!0),S=null,m=null,I=!1,N=null,R=null,A=!1,D=!1,v=null,y=!1,C=!1,H=!1,b=null,G=!1,q=!1,j=!1,V=!1,W=null,Y=!1,z=tn.getBooleanOption(w,"localStorageApp",!1)&&!f,K=tn.getIntegerOption(w,"requiredStorageVersion",0),Q=tn.getIntegerOption(w,"supportedStorageVersion",0),Z=!1,J=On.USE_LOCAL_STORAGE&&!0===ox.secretCookie&&!T.auth_code,X=!1,ee={},te=1,ne=[],re=[],ie=[],oe=null,ae=0,se=!1,le=tn.getBooleanOption(w,"supportsOnlineSync",!0),ce=null,de=!1,ue=!1,ge={},pe="",fe={},Ee=[],he=!0,Oe=!1,_e=[],Se=null,me=null,Ie=!1,Ne=!1,Re=!1,Ae=null,De=null,ve=0,ye=!0,Ce=null,be=null,Te=!1,we="slow load",Fe=!1,Le=[],Ue=0,xe=null,ke=-1,$e=-1,Pe=!1,Me=0,Be=[],He={},Ge=null,qe=null,je=!1,Ve=!1,We=!1;function Ye(e,t){var n=F.getState();F.setRootAttribute("data-app-state",n),F.trigger("docs:state",n,e,t),F.trigger("docs:state:"+n,t),Jn.log("statechange",n,e)}function ze(e){var t,n=G?"error":oe?"preview":I?H||!R?"readonly":Ft()?"sending":A?"ready":"initial":"offline";S!==n&&(t=S,S=n,Ye(t,e))}function Ke(e){R!==e&&(R=e,F.setRootAttribute("data-edit-mode",R),F.trigger("docs:editmode",R),Jn.log("$back{LightPink}changeEditMode",R),F.trigger(R?"docs:editmode:enter":"docs:editmode:leave"),ze())}function Qe(){return{documentFileLockedByUser:b,fullFileName:F.getFullFileName(),oldEditUser:N,isEditor:It()}}function Ze(e,t){var n,r=Rn("Read-Only Mode"),i=null,o=null;return _.isString(e)?(o={type:"info",message:e,headline:r},isNaN(t)||(o.duration=t),o=_.extend({},o,{action:"acquireedit"})):(n=Qe(),i=F.getErrorState(),o=Ce,_.isObject(o)||(_.isObject(i)&&(i.isError()||i.isWarning())?o=un.getMessageData(i,n):(i=F.getInfoState(),_.isString(i)&&(o=gn.getMessageData(i,n))))),F.extendMessageData(o),U.yell(o)}zn.call(this,e,function(){var a=[],N=F.createDeferred("EditApplication.asynchronousLoadFinished"),e=null,t=null,s=$.Deferred(),l=!1,c=!1,R=[],A=[],D=!1,o=-1,d=F.launchTracker;function v(e,t){R.push(t),mn.log("Document status update received during document import")}function y(e,t){A.push(t),mn.log("Clients update received during document import")}function C(e,t){mn.log("Final operation message received for asynchronous load"),f&&!F.isViewerMode()&&t.docStatus&&At(t.docStatus.serverOSN),t.hasErrors||"error"===F.getState()?N.reject(t):s.always(function(){var e,n,r,i;a.push(t),N.resolve((e=a,n={},r=[],i=null,_.each(e,function(e){var t=e.operations;$.extend(n,e),t&&(delete e.operations,r=r.concat(t)),e.rescueOperations&&(i=e.rescueOperations)}),He=n&&n.syncInfo,mn.log("loadDocInfo",He),n.operations=r,i&&(n.rescueOperations=i),_.isEmpty(n.operations)&&n.syncInfo&&o===parseInt(n.syncInfo["document-osn"],10)&&(D=!0),n))})}function b(e,t){var n,r,i,o=null;if(se)return delete t.actions,0<a.length?a[0]=_.extend(a[0],t):a.push(t),void s.resolve();if(n=t,tn.getBooleanOption(n,"preview",!1))return l=!0,void a.push(t);if(l&&!c){c=!0,n=a,r=0,i=[],_.each(n,function(e){r=_.isNumber(e.activeSheet)?e.activeSheet:r,i=i.concat(e.operations)}),o={preview:{activeSheet:r,operations:i}},(a=[]).push(t);o=function(n){var e=new an(n),r=tn.getObjectOption(n,"preview"),e=e.isError()?$.Deferred().reject(n):$.when();r&&_.isArray(r.operations)&&(e=function(){var e=(e=Ct(M,"previewPreProcessing","Preview preprocess handler finished")).then(function(){M=null;var e=vn(n.preview,"operations"),t=e?L.applyExternalOperations(e,{expand:!0}):F.createResolvedPromise();return d.asyncStep(t,"previewApplyOperations","$badge{EditApp} "+(e?e.length:0)+" preview operations applied"),t=t.then(function(){return g.call(F,r)?F.leaveBusyDuringImport():$.when()},function(e){e&&"abort"===e||(n.operationError=!0,n.message=Rn("An unrecoverable error occurred while modifying the document."))})});return d.asyncStep(e,"previewEnd","$badge{EditApp} Preview postprocess handler finished")}());return e}(o);return d.asyncStep(o,"previewProcessing","$badge{EditApp} Preview data processed"),o.done(function(){s.resolve()}),void o.fail(function(){s.reject(),bt(t)})}l||"pending"!==s.state()||s.resolve(),a.push(t)}function r(t){var n,r,e,i,o,a,s,l,c,d,u,g,p,f=or(t),E=(n=t.docStatus,r={},ir.forEach(function(e){e in n&&(r[e]=n[e])}),r),h=new an(t),O=null;function S(e,t){return je=!!e.rescueOperations||tn.getBooleanOption(e.docStatus,"rescueDoc",null),Nt(e).always(function(){_t(e.docStatus)}),me=tn.getStringOption(e.syncInfo,"restore_id",null),Z=tn.getBooleanOption(e.syncInfo,"renameNeedsReload",!1),F.waitForImportSuccess(function(){mn.log("Applying clients update messages, count = "+A.length),_.each(A,function(e){Nt(e)}),mn.log("Applying document update messages, count = "+t.length),_.each(t,function(e){yt(e)}),Ht()&&(P.off(hn.RESPONSE_OPEN_DOC_CHUNK,b),P.off(hn.RESPONSE_OPEN_DOC,C),P.off(hn.BROADCAST_UPDATE_CLIENTS,y).on(hn.BROADCAST_UPDATE_CLIENTS,function(e,t){Nt(t)}),P.off(hn.BROADCAST_UPDATE,v).on(hn.BROADCAST_UPDATE,function(e,t){yt(t)})),ze(),On.DEBUG&&e.rescueOperations&&F.trigger("docs:rescueoperations",e.rescueOperations),N.resolve({action:[]})}),$.when()}function m(){return F.getUserInfo(ox.user_id).done(function(e){k=tn.escapeHTML(e.operationName)})}return F.isViewerMode()&&(H=!0,Ke(!(He={}))),x=tn.getStringOption(t.docStatus,"clientId",""),ee[x]=0,e=null,tn.getBooleanOption(t,"hasErrors",!1)?(kn.error("$badge{EditApp} importHandler: server side error"),e="server"):tn.getBooleanOption(t,"operationError",!1)?(kn.error("$badge{EditApp} importHandler: operation failure"),e=t.message):h.isError()?(kn.error("$badge{EditApp} importHandler: server side error, errorCode="+h.getCodeAsConstant()),e="server"):0===x.length?(kn.error("$badge{EditApp} importHandler: missing client identifier"),e="noclientid"):se||D||_.isArray(f)&&0!==f.length||(kn.error("$badge{EditApp} importHandler: missing document operations"),e="noactions"),O=e?{cause:e}:null,_.isObject(O)?(O=_.extend(O,bt(t)),$.Deferred().reject(O)):(d=!0,u=null,"load"===T.action&&_.isObject(T.file)&&(Mn&&z&&J&&t.syncInfo&&t.syncInfo.fileVersion&&An(t.syncInfo["document-osn"])&&t.syncInfo.fileId&&t.syncInfo.folderId&&_.isFunction(L.setFullModelNode)&&_.isFunction(L.getSupportedStorageExtensions)&&(i=t.syncInfo.fileId+"_"+t.syncInfo.folderId,c=i+"_FILEVERSION",o=i+"_STORAGEVERSION",s=i+"_OSN",l=i+"_OPERATIONS",u=L.getSupportedStorageExtensions(),a=localStorage.getItem(o)&&parseInt(localStorage.getItem(o),10)||1,K<=a?(kn.info("$badge{EditApp} importHandler: document-osn="+t.syncInfo["document-osn"]+", document-rev="+t.syncInfo.fileVersion),localStorage.getItem(c)&&localStorage.getItem(c)===t.syncInfo.fileVersion&&localStorage.getItem(s)&&parseInt(localStorage.getItem(s),10)===parseInt(t.syncInfo["document-osn"],10)?!function(){var e=Gn(l);if(_.isArray(e)){0<f.length&&L.setExternalLocalStorageOperationsExist(!0),f=e.concat(f);e=_.last(f);return _.isNumber(e.osn)||(e.opl=1,e.osn=parseInt(localStorage.getItem(s),10)-1),1}}()?(kn.info("$badge{EditApp} importHandler: required operations in local storage not found. Key: "+l),I()):u.some(function(e){var t=i+e.extension,n={usedLocalStorage:!0};_.isObject(e.additionalOptions)&&_.extend(n,e.additionalOptions);var r=localStorage.getItem(t);if(r)kn.info("$badge{EditApp} importHandler: loading document from local storage. Key: "+t+" Length: "+localStorage.getItem(t).length),X=!0,we="local storage",L.setFullModelNode(r,n);else{if(!e.optional)return kn.info("$badge{EditApp} importHandler: key in local storage not found. Key: "+t+". But found OSN key: "+s),I(),!(X=!1);kn.info("$badge{EditApp} importHandler: optional local storage value not found. Key: "+t)}}):(kn.info("$badge{EditApp} importHandler: file in local storage not found. Key: "+i),I())):(kn.info("$badge{EditApp} importHandler: version of file in local storage not supported. Key: "+i),I())),X&&L.trigger("update:model",{usedLocalStorage:!0})),d?(g="",p=tn.getBooleanOption(t,"fastLoad",!1),X||(!t.htmlDoc&&On.DEBUG&&!se&&L.setFullModelNode&&p&&F.getFileDescriptor()&&!Tn(F.getFileDescriptor().filename,"_ox")&&U.yell({type:"error",headline:_.noI18n("Error in fastload"),message:_.noI18n('you should have a look in the backend logfiles ("Exception while creating the generic html document")')}),t.htmlDoc&&_.isFunction(L.setFullModelNode)&&!se&&(kn.info("$badge{EditApp} importHandler: load complete HTML document, osn: ",t.syncInfo["document-osn"]),(p=JSON.parse(t.htmlDoc)).mainDocument&&L.setFullModelNode(p.mainDocument),p.headerFooter&&(_.each(p.headerFooter,function(e){g+=e}),L.setFullModelNode(g,{headerFooterLayer:!0}),L.getPageLayout().headerFooterCollectionUpdate()),p.comments&&(g="",_.each(p.comments,function(e){g+=e}),L.setFullModelNode(g,{commentLayer:!0})),we="fast load",L.trigger("fastload:done"))),R.unshift({docStatus:E}),se?(we="fast empty",S(t,R).then(m)):Ct(M,"preProcessing","Import preprocess handler finished").then(m).then(function(){return Ct(function(){var e=w&&w.applyActionsDetached;e&&U.detachAppPane();var t=L.applyExternalOperations(f,{expand:!0});return e&&U.finally(t,U.attachAppPane),t},"applyOperations",f.length+" document operations applied").then(function(){if(L.getOperationStateNumber()<0)return $.Deferred().reject({cause:"applyactions",headline:Rn("Synchronization Error")});var e=X&&!L.externalLocalStorageOperationsExist();return Ct(B?B.bind(F,e):null,"postProcessing","Import postprocess handler finished").then(function(){return S(t,R)},function(e){return _.extend({cause:"postprocess"},e)})},function(e){if(Ht()&&P.off(hn.RESPONSE_OPEN_DOC,C),"destroy"!==e)throw _.extend({cause:"applyactions"},e)})},function(e){throw _.extend({cause:"preprocess"},e)})):$.Deferred().reject({cause:"localStorageFailed",headline:_.noI18n("LocalStorage failure")}));function I(){_.each(u,function(e){localStorage.removeItem(i+e.extension)}),localStorage.removeItem(s),localStorage.removeItem(o),localStorage.removeItem(c),localStorage.removeItem(l)}}L.undoManager.on("undogroup:open",function(){i=Tt()}),L.undoManager.on("undogroup:close",function(){wt()&&$t(i),i=null,L.setInternalOperationBlocker(!1)}),L.on("operations:success",function(e,t,n,r){n||Oe||(_.isObject(i)?(mn.log("operations:success - push operations into pending action"),i.operations=i.operations.concat(t),r&&(i.userData=r)):$t(Tt(t,r)))}),L.on("cacheBuffer:flush",function(){mn.log("cacheBuffer:flush received - send cached operations"),_.isFunction(p)&&_e.length&&(u=p.call(F,u,_e),kt())}),L.on("operations:error",function(){F.isImportFinished()?(F.setInternalError(cn.ERROR_WHILE_MODIFYING_DOCUMENT,sn.GENERAL),mn.error("An unrecoverable error occurred while modifying the document")):(F.setInternalError(cn.ERROR_WHILE_LOADING_DOCUMENT,sn.GENERAL),mn.error("An unrecoverable error occurred while loading the document"),N.reject())}),F.getWindowNode().on("drop",!1),P=F.isViewerMode()||tn.getBooleanOption(T,"isAttachmentFile",!1)?new In(F,w):new mn(F);this.rtConnection=P,se||U.enterBusy({skipCancelOnReadOnly:!0,cancelHandler:function(){F.isInQuit()||(qt(".abortOpen"),Vt(),F.quit())},immediate:!0,topLabel:_.noI18n(F.getFullFileName()),warningLabel:Rn("Sorry, your document is very large. It will take some time to be loaded."),warningDelay:1e4});Ht()&&(P.on(En.EVENT_OFFLINE,rt),P.on(En.EVENT_ONLINE,it),P.on(En.EVENT_ERROR,function(e,t){!function(e,t){var n;mn.log("Error handler called by RT2 communication layer, cause = "+JSON.stringify(e)),t&&"pending"===t.state()&&t.reject(e);_.isObject(e)&&_.isString(e.error)&&(n=new an(e));F&&("GENERAL_SESSION_INVALID_ERROR"===n.getCodeAsConstant()?(de=!0,st("RT")):"GENERAL_DOCUMENT_ALREADY_DISPOSED_ERROR"===n.getCodeAsConstant()?_.isString(ce)?(de=!0,f?St({cause:"error:disposed"}):mt(0,null,null,{cause:"error:disposed"})):F.setInternalError(n,sn.CONNECTION):"TOO_MANY_CONNECTIONS_ERROR"===n.getCodeAsConstant()?(de=!0,ce=null,F.setInternalError(n,sn.CONNECTION)):F.isLocked()||F.isInQuit()||_.isString(ce)?_.isString(ce)&&(de=!0,f?St({cause:"reset"}):mt(0,null,null,{cause:"reset"})):"HANGUP_INVALID_OPERATIONS_SENT_ERROR"===e.error||"HANGUP_INVALID_OSN_DETECTED_ERROR"===e.error||"GENERAL_OFFLINE_CLIENT_IN_NON_SYNC_STATE"===e.error?F.setInternalError(e,sn.CONNECTION):"HANGUP_NO_EDIT_RIGHTS_ERROR"===e.error?F.restoreDocument(n):(n=cn.ERROR_UNKNOWN_REALTIME_FAILURE,F.setInternalError(e,sn.CONNECTION)))}(t,N)}),P.on(En.EVENT_NORESPONSE_IN_TIME,lt),P.on(hn.BROADCAST_UPDATE,v),P.on(hn.BROADCAST_UPDATE_CLIENTS,y),P.on(hn.BROADCAST_SHUTDOWN,ct),P.on(hn.BROADCAST_CRASHED,dt),P.on(hn.BROADCAST_RENAMED_RELOAD,ft),P.on(hn.BROADCAST_HANGUP,ut),P.on(hn.BROADCAST_OT_RELOAD,gt));return d.step("initImport","$badge{EditApp} Import process initializated"),t=function(){var t=F.createDeferred("EditApplication.establishConnection");return Ct(function(){var e=Ht()?P.connect():F.createRejectedPromise();return mn.log("Channel UID:",Ht()?P.getChannelUID():null),Ge=Ht()?P.getDocUID():"null",qe=Ht()?P.getClientUID():"null",(e=(e=e.then(function(e){var t=new an(e);if(e.hasErrors||t.isError())throw e;return e})).then(function(t){var e=new an(t);if(e.isWarning()&&"ADVISORY_LOCK_SET_WARNING"===e.getCodeAsConstant()){var n=JSON.parse(e.getErrorValue()),e=new Date(n.since),r=Sn.format(e,Sn.getDateFormat())+" "+Sn.format(e,Sn.getTimeFormat()),i=Rn("Document in use");return F.getUserInfo(n.uid).then(function(e){e=Rn("%1$s edits this document since %2$s on %3$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",Rn.noI18n(e.displayName),Rn.noI18n(r),Rn.noI18n(n.hostName));return U.showQueryDialog(i,e)},function(){var e=Rn("Another user edits this document since %1$s on %2$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",Rn.noI18n(r),Rn.noI18n(n.hostName));return U.showQueryDialog(i,e)}).then(function(){return F.quit(),t},function(e){if("close"===e)throw e;return t=_.extend({advisoryLock:"reset"},t)})}return t})).done(function(e){t.resolve(e)}),e.fail(function(e){t.reject(e)}),t.promise()},"connect","Realtime connection established")}(),Je(),(e=t.then(function(e){var t=new an(e),n={fastEmpty:se};if(!t.isError())return Ht()&&(P.on(hn.RESPONSE_OPEN_DOC_CHUNK,b),P.on(hn.RESPONSE_OPEN_DOC,C)),T.auth_code&&(n=_.extend({auth_code:T.auth_code},n)),e&&e.advisoryLock&&(n=_.extend({advisoryLock:e.advisoryLock},n)),"new"===T.action&&(n=_.extend({newDoc:!0},n)),se&&(n=_.extend({fastEmptyOSN:L.getOperationStateNumber()},n)),Mn&&!se&&J&&(function(e,t){if("load"!==e.action||!_.isObject(e.file))return;var n=e.file.id+"_"+e.file.folder_id,r=n+"_OSN",e=n+"_FILEVERSION",n=n+"_STORAGEVERSION",r=localStorage.getItem(r),e=localStorage.getItem(e);localStorage.getItem(n)>=K&&r&&e&&(r=parseInt(r,10),e=parseInt(e,10),_.isNumber(r)&&_.isNumber(e)&&(t.storageOSN=r,t.storageVersion=e))}(T,n),o=n.storageOSN),Ht()&&P.open(n),N.then(r,function(e){return Cn(e)});bt(e)}).catch(function(e){return Cn(bt(e))})).always(function(){oe=null,ze()}),e},T,_.extend({},w,{initHandler:function(){var e=Zn();On.DEBUG&&(e=e.then(function(){return xn("io.ox/office/debug/common/main",function(e){return e.initializeApp(F)})}));return e},initFileHandler:function(){if(!F||!T)return kn.warn("$badge{EditApp} initFileHandler: called on an already destroyed instance."),$.Deferred().reject();var e={},n=!1,r=F.launchTracker;e.initial_language=ox.language.replace(/_/g,"-"),T.cryptoAction&&(e.cryptoAction=T.cryptoAction);T.decrypt_auth_code&&(e.cryptoAuth=T.decrypt_auth_code,e.encrypted_file=!0);switch(tn.getStringOption(T,"action","load")){case"load":return on.isDriveFile(T.file)?on.getFile(T.file).done(function(e){T.file=e}):$.when();case"convert":n=!0;break;case"new":var t=w&&w.prepareNewDocHandler;t&&_.extend(e,t.call(F));break;default:return kn.error("$badge{EditApp} initFileHandler: unsupported launch action"),$.Deferred().reject()}var i=tn.getObjectOption(T,"templateFile"),o=tn.getBooleanOption(T,"preserveFileName",!1),t=tn.getStringOption(T,"target_filename",rr),a=tn.getStringOption(T,"target_folder_id",""),s=tn.getObjectOption(i,"origin");function l(e){return F.setInternalError(e,sn.CREATEDOC),$.Deferred().reject({cause:n?"convert":"create"})}_.extend(e,{action:"createdefaultdocument",document_type:F.appType,target_filename:t,target_folder_id:a,preserve_filename:o,convert:n}),T.template&&_.extend(e,{action:"createfromtemplate",file_id:i.id});_.isObject(i)&&_.extend(e,{file_id:i.id,version:i.version});F.waitForImportSuccess(function(){var e=F.getFileDescriptor(),t=!T.template&&a!==e.folder_id;(T.template?e.converted:n)?F.setCurrentInfoState(t?dn.INFO_DOC_CONVERT_STORED_IN_DEFFOLDER:dn.INFO_DOC_CONVERTED_AND_STORED):t&&F.setCurrentInfoState(dn.INFO_DOC_CREATED_IN_DEFAULTFOLDER)});o=_.url.hash("fields"),i=_.url.hash("fields-source");(o||i)&&(_.url.hash("fields",null),_.url.hash("fields-source",null),e.fields=o,e.sourcefields=i);e=F.sendRequest(Un,e);return e=e.then(function(e){var t=new an(e);return t.isError()?l(t):e},function(){return l()}),r.asyncStep(e,"createNewDocAfterRequest","$badge{EditApp} New file in remote storage created"),(e=(e=e.then(function(t){return on.getFile(t.file).then(function(e){return t.file=e,t})})).then(function(e){function t(t,n){var e=F.isPresentationApp()?F.createResolvedPromise():F.leaveBusyDuringImport(!t,{immediateShow:!0});return r.asyncStep(e,"afterLeaveBusyEarly","$badge{EditApp} Busy state after creation of document left"),e.then(function(){if(t)return n;throw n},function(e){throw t?e:n})}return _.isObject(e.file)?(s&&(e.file.origin=s),e.file.source="drive",e.converted&&(e.file.converted=e.converted),(se=_.isString(e.htmlDoc)&&_.isArray(e.operations)&&0<e.operations.length)&&c?c.call(F,e.htmlDoc,e.operations).then(t.bind(null,!0),t.bind(null,!1)).then(function(){return e}):e):(kn.error("$badge{EditApp} initFileHandler: missing file descriptor"),$.Deferred().reject())})).then(function(e){return e.file})},flushHandler:function(e){if(G)return Cn();var t=Pt(e);e===Vn.QUIT&&t.always(function(){Ke(!1)});return t=t.then(function(){return Ht()?P.flushDocument():Cn()})},messageDataHandler:ar,printOptionsHandler:function(){return Ht()?{doc_uid:P.getDocUID(),client_uid:P.getClientUID()}:null}}));var Je=On.DEBUG?function(){J=F.getUserSettingsValue("debugUseLocalStorage",J)&&!F.isDocumentEncrypted()}:$.noop;function Xe(e){e=_.findWhere(ne,{clientUID:e});return e&&e.userName||""}var et=On.LOG_PERFORMANCE_DATA?function(){var i=U.toolBarTabs,o=0;i.on("tab:activated",function e(t,n){var r;o++,n&&(r="tabActivated_"+Fn(n),F.launchTracker.step(r,'$badge{EditApp} Toolbar tab "'+n+'" activated')),2===o&&i.off("tab:activated",e)})}:$.noop;function tt(){function e(){F.getController().update().done(function(){F.launchTracker.step("considerToolbarUIStable","$badge{EditApp} Toolbar is visually stable"),F.isReloading()&&F.setAppReloadDone(F)})}function t(){Re=!0,F.showEditToolbarAtStart()?U.one("edittoolpane:layout:finished",e):U.one("docs:toolpane:unhide",function(){F.executeDelayed(function(){e()},"registerFirstTabActivatedHandler.unhideToolpaneHandler",150)})}F.showEditToolbarAtStart()?U.toolBarTabs.one("tab:activated",t):F.waitForImportSuccess(t)}function nt(e){var t=an.isErrorCode(e)?e:function(e){var t;switch(e){case"reset":t=new an(cn.ERROR_CONNECTION_RESET_RECEIVED);break;case"timeout":t=new an(cn.ERROR_CONNECTION_TIMEOUT);break;case"notMember":t=new an(cn.ERROR_CONNECTION_NOT_MEMBER);break;default:t=new an(cn.ERROR_UNKNOWN_REALTIME_FAILURE)}return t}(e);t.setErrorContext(sn.CONNECTION),Ht()?(e=P.hasPendingActions()||F.hasUnsavedChangesOffice(),Ke(!(H=!0)),e?f?F.setInternalError(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,sn.CONNECTION):F.restoreDocument(t):(T.action="load",delete T.template,F.reloadDocument())):F.setInternalError(t,sn.CONNECTION)}function rt(){V=!0,I&&!G&&!F.isInQuit()&&Ht()&&(j=R,I=!1,f&&xe.abort(),ce?P.hasPendingActions()?F.setInternalError(cn.ERROR_OFFLINE_WHILE_SYNC_LOCAL_CHANGES,sn.OFFLINE):F.setInternalError(cn.ERROR_OFFLINE_WHILE_SYNCHRONIZING,sn.OFFLINE):(Ke(!(H=!0)),ze(),F.setInternalError(cn.WARNING_READONLY_DUE_TO_OFFLINE,sn.OFFLINE)),mn.log("Connection offline handler called by Realtime!"),ht())}function it(){!V||I||G||F.isInQuit()||(mn.log("Connection online handler called by Realtime!"),f&&Zt(),I=!0,le&&(f?function(){if(mn.log("Client supports synchronization - starting to sync with server"),!_.isObject(F))return;j?(F.setInternalError(cn.WARNING_SYNC_AFTER_OFFLINE,sn.SYNCHRONIZATION),mn.log("Client is editor - synchronizing with server using current client state"),ce="editSync",u&&0<u.length&&kt()):(F.setInternalError(cn.WARNING_SYNC_FOR_VIEWER,sn.SYNCHRONIZATION),mn.log("Client is viewer - waiting for server messages to unlock view"),ce="viewSync");{F.executeDelayed(function(){!de&&ce&&(mn.log("Synchronization time out detected - no synchronization possible"),St({cause:"timeout"}))},"EditApplication.startSynchronizationProcessOT",3e4),ce&&Ht()&&P.sync().then(function(){de||P.syncStable().then(function(e){mn.log("SyncStable response received ",e),e&&e.docStatus?St(null):St({cause:"reset"})},function(){St({cause:"reset"})})}).done(function(){F.repeatDelayed(function(){return!ce||de?tn.BREAK:Ht()?void St(null):(St({cause:"reset"}),tn.BREAK)},"EditApplication.startSynchronizationProcessOT",{delay:0,repeatDelay:3e3,cycles:9})})}}:function(){if(mn.log("Client supports synchronization - starting to sync with server"),!_.isObject(F))return;j?(F.setInternalError(cn.WARNING_SYNC_AFTER_OFFLINE,sn.SYNCHRONIZATION),mn.log("Client is editor - synchronizing with server using current client state"),ce="editSync",u&&0<u.length&&kt()):(F.setInternalError(cn.WARNING_SYNC_FOR_VIEWER,sn.SYNCHRONIZATION),mn.log("Client is viewer - waiting for server messages to unlock view"),ce="viewSync");{var n,r;F.executeDelayed(function(){!de&&ce&&(mn.log("Synchronization time out detected - no synchronization possible"),mt(0,null,null,{cause:"timeout"}))},"EditApplication.startSynchronizationProcess",3e4),ce&&Ht()&&(n=-1,r=null,P.sync().then(function(e){if(mn.log("Sync response received ",e),e&&e.docStatus){var t=L.getOperationStateNumber();return r=tn.getStringOption(e.docStatus,"editUserId",""),n=tn.getIntegerOption(e.docStatus,"serverOSN",-1),mt(W=r,t,n,null),$.when()}throw new Error("sync response contains no mandatory data - synchronization impossible!")},function(){mt(0,null,null,{cause:"reset"})}).then(function(){if(ce&&Ht()){var e=P.syncStable();return e.done(function(e){var t;mn.log("SyncStable response received ",e),e&&e.docStatus?(t=L.getOperationStateNumber(),r=tn.getStringOption(e.docStatus,"editUserId",""),mt(W=r,t,n,null)):mt(0,null,null,{cause:"reset"})}),e.fail(function(){mt(0,null,null,{cause:"reset"})}),e}throw mt(0,null,null,{cause:"reset"}),new Error("synchronization not possible")},function(){mt(0,null,null,{cause:"reset"})}).done(function(){F.repeatDelayed(function(){if(!ce||!Ht())return mt(0,null,null,{cause:"reset"}),tn.BREAK;var e=L.getOperationStateNumber();mt(_.isString(r),e,n,null)},"EditApplication.startSynchronizationProcess",{delay:0,repeatDelay:3e3,cycles:9})}))}})(),ze(),Ze())}function ot(){var n;mn.log("EditApp: handleSessionChanged called, process is already running? ",We),We||(We=!0,Te||at(),F.hasUnsavedChangesOffice()?(mn.log("EditApp: handleSessionChanged, has unsaved local changes"),F.setInternalError(cn.ERROR_SESSION_LOST_WITH_LOCAL_CHANGES,sn.CONNECTION)):(mn.log("EditApp: handleSessionChanged, no unsaved local changes"),n=cn.ERROR_SESSION_LOST_WITH_UNKNOWN_DOCUMENT_STATE,F.sendFileRequest(Un,{action:"getdocumentstate"}).then(function(e){var t=new an(e);return t.isError()?(n=n||t,kn.warn("EditApp: checkDocumentSaved received no save status, reason: ",t&&t.getCodeAsConstant()),F.setInternalError(n,sn.CONNECTION),!1):e.syncInfo["document-osn"]>=$e},function(e){return kn.error("EditApp: checkDocumentSaved",e),!1}).always(function(e){mn.log("EditApp: handleSessionChanged, document is saved on server: ",e),e?F.reloadDocument():F.setInternalError(cn.ERROR_SESSION_LOST_WITH_LOCAL_CHANGES,sn.CONNECTION)})))}function at(){H=Te=!0,Vt()}function st(e){mn.log("EditApp: handleSessionInvalidError called, process is already running: ",Te,"; detected by: ",e),Te||(at(),F.setInternalError(cn.WARNING_SESSION_INVALID_DETECTED,sn.CONNECTION),"RT"===e&&F.requestRelogin())}function lt(){mn.log("NoResponseInTime notification received - Server has not responded in a certain time"),F.isLocked()||F.isInQuit()||F.setInternalError(cn.WARNING_CONNECTION_INSTABLE)}function ct(){var e,t;mn.log("Shutdown notification received - Document middleware node is going down!"),F.isLocked()||F.isInQuit()||!Ht()||(e=P.hasPendingActions()||F.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}},R&&e?F.setInternalError(cn.ERROR_SERVER_SHUTDOWN_NO_RESCUE_POSSIBLE,sn.CONNECTION,null,t):F.setInternalError(cn.ERROR_SERVER_GOING_TO_SHUTDOWN,sn.CONNECTION,null,t))}function dt(){var e,t;mn.log("Crashed node notification received - Document middleware node is not available anymore!"),F.isLocked()||F.isInQuit()||!Ht()||(e=P.hasPendingActions()||F.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}},R&&e?F.setInternalError(cn.ERROR_SERVER_NODE_UNAVAILABLE_NO_RESCUE_POSSIBLE,sn.CONNECTION,null,t):F.setInternalError(cn.ERROR_SERVER_NODE_UNAVAILABLE,sn.CONNECTION,null,t))}function ut(e,t){var n;mn.log("Hangup notification received - document cannot be edited anymore!"),F.isLocked()||F.isInQuit()||!Ht()||(n=P.hasPendingActions()||F.hasUnsavedChanges(),(t=new an(t)).isError()||(t=new an(cn.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),It()&&(n||function(e){var t=!1;if(an.isErrorCode(e)&&e.isError()){switch(e.getCodeAsConstant()){case"SAVEDOCUMENT_FILE_HAS_CHANGED_ERROR":case"GENERAL_FILE_NOT_FOUND_ERROR":case"GENERAL_PERMISSION_READ_MISSING_ERROR":case"GENERAL_PERMISSION_WRITE_MISSING_ERROR":case"LOADDOCUMENT_CANNOT_RETRIEVE_OPERATIONS_ERROR":t=!0}}return t}(t))?f?F.setInternalError(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,sn.CONNECTION):F.restoreDocument(t):"GENERAL_MALICIOUS_ACK_HANDLING_ERROR"!==t.getCodeAsConstant()||n?F.setInternalError(t,sn.CONNECTION):F.reloadDocument())}function gt(e,t){mn.log("OT reload notification received - client must reload the document"),F.isInQuit()||((t=new an(t)).isError()||(t=new an(cn.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),pt(t,sn.CONNECTION))}function pt(e,t){F.trigger("docs:reload:prepare"),F.setInternalError(e,t),F.executeDelayed(function(){F.reloadDocument()},"EditApplication.handleReload",1500)}function ft(e,t){var n,r;F.isInQuit()||(new an(t).isError()?Se&&Se.reject(t):(n=tn.getStringOption(t,"fileId",null),r=tn.getStringOption(t,"fileName",null),n&&r?(Se&&Se.resolve(t),F.updateFileDescriptor({id:n,filename:r,title:on.getFileBaseName(r)}),T.action="load",delete T.template,A=!1,F.reloadDocument()):Se&&Se.reject(t)))}function Et(e){if(Jn.log("$back{lightgreen}handleEditRequestViaUpdate",e),!F.isInQuit()&&null===ce&&!Y&&W===x){var e=e&&_.isArray(e.activeUsers)?_.find(e.activeUsers,function(e){return e&&e.clientUID!==x&&e.requestsEditRights}):null,t=e?e.clientUID:null;if(t){if(Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - clientUIDRequesting ",De,Xe(t)),De)return Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - BLOCK OTHER REQUESTS?",t),void(De.clientUID!==t&&Ht()&&(Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - REQUEST BLOCKED!"),P.declineEditRights(t)));Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - Request edit rights",a);e=function(e){if(Jn.log("$back{MediumAquaMarine}handleEditRightsTransferRequest"),function(){var e=12e4,t=0<a,n=null,r=_.now()-ve;Jn.log("inactivCheck knownWhenLastOpWasSend",t),t?(n=Date.now()-a,Jn.log("inactivCheck sendActionsTime",a,n)):(n=Date.now()-ae,Jn.log("inactivCheck importFinishedTime",ae,n));return Jn.log("inactivCheck User is inactive?",e<n,!tn.wasKeyPressedWithinTime(e),"timeDeltaToLastTransfer",r,e<r),e<n&&!tn.wasKeyPressedWithinTime(e)&&e<r}())return yn(nr);var i=F.newDeferred("EditApplication.handleEditRightsTransferRequest"),t=F.createAbortablePromise(i);De={deferred:i,promise:t,clientUID:e},Jn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - callForUserInput"),U.yell({type:"question",message:Rn("%1$s is asking for edit rights. This request will be accepted automatically in %2$d seconds.",Xe(e),Math.floor(Hn/1e3)),duration:Hn,progress:!0,disableCloser:!0,restoreHidden:!0,priority:!0,renderFn:function(e){var t=$.button({label:Rn("Decline")}).addClass("btn-default").css({marginRight:5});t.on("click tab",function(){Jn.log("$back{Orchid}__handleEditRightsTransferRequest - DECLINE BUTTON PRESSED BY USER"),ve=Date.now(),Jn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: declined"),i.resolve(tr)});var n=$.button({label:Rn("Accept")}).addClass("btn-primary");n.on("click tab",function(){Jn.log("$back{Orchid}__handleEditRightsTransferRequest - ACCEPT BUTTON PRESSED BY USER"),Jn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: accepted"),i.resolve(er)});var r=$('<div class="button-area" style="text-align:center;margin-top:10px;">');e.append(r.append(t,n))}});var n=F.executeDelayed(function(){Jn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - DECISION: accepted automatically"),i.resolve(er)},"EditApplication.handleEditRightsTransferRequest.autoAcceptTimer",{delay:Hn,background:!0});return t.always(function(){De=null,n.abort(),U&&U.hideYell({priority:!0})}),t}(t);e.done(function(e){if(Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - answer: "+e),e===tr)return Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer declined"),void(Ht()&&P.declineEditRights(t));Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer accepted"),Ke(!(Y=!0)),F.setCurrentInfoState(dn.INFO_PREPARE_LOSING_EDIT_RIGHTS,{showMessage:e===nr}),ze(),F.getController().update();e=w&&w.prepareLoseEditRightsHandler;(e?bn(e.bind(F)):yn()).always(function(){mn.log("handle PrepareLosingEditRights"),F.executeDelayed(function(){!function e(t){F.hasUnsavedChangesOffice()?F.executeDelayed(function(){e(t)},"EditApplication.checkForPendingOperations",2e3):kt().then(function(){Ht()&&P.canLoseEditRights(t),Y=!1,F.getController().update(),mn.log("sent canLoseEditRights")})}(t)},"EditApplication.handlePrepareLosingEditRights",1e3)})}),e.fail(function(e){Jn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer failure, reason:",e)})}}}function ht(){Ae.abort(),Jn.log("$back{SandyBrown}abortPendingEditRightsRequest")}function Ot(){De&&(De.promise.abort(),Jn.log("abortPendingEditRightsTransfer"))}function _t(t){Jn.log("$back{lightblue}applyEditState - DOC UPDATE",t);var e=f?null:tn.getStringOption(t,"editUserId",""),n=f?null:Xe(e),r=f?null:n||t.editUser,i=f?null:R,o=f?null:i,a=F.getFileDescriptor(),s=L.getOperationStateNumber(),l=f?null:tn.getIntegerOption(t,"serverOSN",-1),c=new an(t),d=tn.getIntegerOption(t,"lockedByUserId",-1),n=tn.getBooleanOption(t,"writeProtected",null);if(f?mn.log("$badge{EditApp} applyEditState: clientOSN = "+s):mn.log("$badge{EditApp} applyEditState: clientOSN = "+s+", localServerOSN = "+l),!G&&ir.some(function(e){return e in t})){if(f||e===W||(mn.log("Edit rights changed, new editing user id: "+e),o=x===e,F.setCurrentInfoState(dn.INFO_USER_IS_CURRENTLY_EDIT_DOC,{showMessage:!1}),Jn.log("$back{lightblue}__applyEditState - EDITOR HAS BEEN CHANGED","|editClientId:",e,"|oldEditClientId:",W),Ae.running&&""!==e&&(Jn.log("$back{lightblue}__applyEditState - FORCE TIMER ABORTED the editor has been changed"),ht())),tn.getBooleanOption(t,"failSafeSaveDone",!1)&&on.propagateChangeFile(a),tn.getBooleanOption(t,"hasErrors",!1))return F.setInternalError(cn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,sn.SYNCHRONIZATION),void mn.error("synchronization to the server has been lost.");H||(On.RESCUE_DOCUMENT_READONLY&&F.isRescueDocument()?(Ke(!(H=!0)),F.setInternalError(cn.WARNING_RESCUE_DOC_CANNOT_BE_CHANGED,sn.READONLY)):_.isBoolean(n)&&n||tn.getBooleanOption(T,"isAttachmentFile",!1)?(Ke(!(H=!0)),F.setInternalError(cn.WARNING_NO_PERMISSION_FOR_DOC,sn.READONLY,null,{showMessage:!L.isValidReadOnlyMode(),hideError:L.isValidReadOnlyMode()})):-1!==d&&ox.user_id!==d&&(Ke(!(H=!0)),F.setInternalError(cn.WARNING_DOC_IS_LOCKED,sn.READONLY),b=tn.getStringOption(t,"lockedByUser",""))),H||Y||(f?Ke(!0):(mn.log("Edit mode: "+o),Ke(o),!o&&(!I||i||r!==N&&r.length)&&(N=r,F.setCurrentInfoState(dn.INFO_USER_IS_CURRENTLY_EDIT_DOC)),I&&e&&e!==W&&(function(e){var t=W,n=e,e=[n];_.isString(t)&&0<t.length&&e.push(t);W=n,Nt(e)}(e),N=r),o&&!1===i&&F.setCurrentInfoState(dn.INFO_EDITRIGHTS_RECEIVED),I&&!o&&i&&-1!==l&&l<s&&(F.setInternalError(cn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,sn.SYNCHRONIZATION),mn.error("synchronization between client and server is broken. Switching editor into read-only mode. New edit mode: "+o+"Old edit mode: "+i+", local Server OSN: "+l+", Client OSN: "+s))),(c.isError()||c.isWarning())&&F.setInternalError(c,sn.GENERAL)),I=!0,ze()}}function St(e){var t=null,n=function(){if(0<u.length)return!0;var e=Ht()?P.getPendingActions():null;return e&&_.isArray(e.actions)&&0<e.actions.length}();function r(){mn.log("logSynchronizationState... ","\n     localChanges = ",n,"\n     rtConnection.getPendingActions() = ",Ht()&&JSON.stringify(P.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(u),"\n     mustSyncNowMode = ",ce,"\n     failedData = ",JSON.stringify(e))}if(ce){if(mn.log("Checking synchronization state with server"),e){switch(e.cause){case"timeout":mn.log("Synchronization not possible - maybe connection instance is gone"),(t=new an(cn.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(sn.SYNCHRONIZATION),r(),ce=null;break;case"notMember":case"reset":case"error:disposed":mn.log("Synchronization not possible - connection instance is gone or rt-state broken"),(t=new an(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(sn.SYNCHRONIZATION),r(),ce=null}nt(t)}switch(ce){case"editSync":if(n)return;mn.log("Synchronization successfully completed"),Ke(!(H=!1)),F.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0});break;case"viewSync":mn.log("Synchronization for viewer completed"),F.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})}r(),ce=null}}function mt(e,t,n,r){var i=null,o=function(){if(0<u.length)return!0;var e=Ht()?P.getPendingActions():null;return _.isObject(e)&&_.isArray(e.actions)&&0<e.actions.length}();function a(e,t){mn.log("logSynchronizationState... ","\n     localChanges = ",o,"\n     rtConnection.getPendingActions() = ",Ht()&&JSON.stringify(P.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(u),"\n     mustSyncNowMode = ",ce,"\n     clientOSN = ",e,"\n     serverOSN = ",t,"\n     oldEditUser = ",N,"\n     failedData = ",JSON.stringify(r))}if(ce){if(mn.log("Checking synchronization state with server"),r){switch(r.cause){case"timeout":mn.log("Synchronization not possible - maybe connection instance is gone"),(i=new an(cn.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(sn.SYNCHRONIZATION),a(t,n),ce=null;break;case"notMember":case"reset":case"error:disposed":mn.log("Synchronization not possible - connection instance is gone or rt-state broken"),(i=new an(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(sn.SYNCHRONIZATION),a(t,n),ce=null}nt(i)}switch(ce){case"editSync":if(It()){if(o)return;mn.log("Synchronization successfully completed"),Ke(!(H=!1)),F.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0})}else o?(mn.log("Synchronization not possible - editor changed"),(i=new an(cn.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)).setErrorContext(sn.SYNCHRONIZATION),F.restoreDocument(i)):n<=t?(mn.log("Synchronization possible - but we lost edit rights"),H=!1,F.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(mn.log("Synchronization not possible - did not receive missing operations"),F.reloadDocument());break;case"viewSync":n<=t?(mn.log("Synchronization for viewer completed"),H=!1,F.setCurrentInfoState(dn.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(mn.log("Synchronization not possible - did not receive missing operations"),F.reloadDocument())}a(t,n),ce=null}}function It(){return f||x===W}this.getServerModuleDocUrl=function(e,t,n){if(!Ht()||!ox.session||!this.hasFileDescriptor())return null;n=this.getFileParameters(_.extend({},n,{encodeUrl:!0}));return t=_.extend({session:ox.session,uid:this.get("uniqueID"),docuid:P.getDocUID()},n,t),ox.apiRoot+"/"+e+"?"+_.map(t,function(e,t){return t+"="+e}).join("&")};var Nt=this.synchronize(function(e){Jn.log("$back{PaleGoldenRod}applyUserData: CLIENT UPDATE",e);var t=null;if(_.isArray(e)?(t={clients:{changed:[]}},_.each(e,function(e){t.clients.changed.push({clientUID:e})})):t=e,!_.isObject(t))return kn.error("$badge{EditApp} applyUserData: called without valid data: "+JSON.stringify(t)),$.when();var n,r=re,e=tn.getObjectOption(t,"clients",{}),i=[],o=[];return W===x&&_.isArray(e.changed)&&0<e.changed.length&&Et({activeUsers:e.changed}),_.isArray(e.list)?o=e.list:(_.isArray(e.left)||_.isArray(e.joined)||_.isArray(e.changed))&&(n={},re.forEach(function(e){n[e.clientUID]=e}),_.isArray(e.left)&&e.left.forEach(function(e){delete n[e]}),_.isArray(e.joined)&&e.joined.forEach(function(e){n[e.clientUID]=e}),_.isArray(e.changed)&&e.changed.forEach(function(e){n[e.clientUID]=_.extend({},n[e.clientUID],e)}),Object.keys(n).forEach(function(e){o.push(n[e])})),0===o.length?$.when():(_.each(o,function(t){var e=_.isObject(t)&&_.isString(t.clientUID),n=e&&!_.isNumber(t.userId)&&_.isNumber(t.id);e?n?i.push(F.getUserInfo(t.id).then(function(e){return t.userDisplayName=e.displayName,t.userOperationName=e.operationName,t})):i.push($.when(t)):kn.warn("$badge{EditApp} applyUserData: missing identifier")}),F.createResolvedPromise().then(function(){return $.when.apply($,i)}).done(function(){var e,t;ne=_.map(arguments,function(t){var e=t;_.isNumber(t.userId)||((e={}).clientUID=t.clientUID,e.userId=t.id,e.userName=t.userDisplayName,e.userOperationName=t.userOperationName,e.guest=t.guest);var n=_.find(r,function(e){return e.active&&e===t.clientUID}),n=_.isNumber(t.durationOfInactivity)&&t.durationOfInactivity<60&&n;return e.active=!0===t.active||n,e.remote=x!==e.clientUID,e.editor=W===e.clientUID,_.isObject(t.userData)&&(e.userData=t.userData),e.clientUID in ee||(ee[e.clientUID]=te,te+=1),e.clientIndex=ee[e.clientUID],e.colorIndex=F.getAuthorColorIndex(e.userOperationName),e}),re=_.where(ne,{active:!0}),re=_.sortBy(re,"clientIndex"),_.isEqual(r,re)||(kn.info("$badge{EditApp} applyUserData: activeClients=",re),t=re,(e=r).length===t.length&&(e=_.copy(e,!0),t=_.copy(t,!0),_.each(e,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.each(t,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.isEqual(e,t))||F.trigger("docs:users",re),De&&!_.findWhere(re,{clientUID:De.clientUID})&&Ot(),e=_.first(_.pluck(_.where(r,{clientUID:x}),"requestsEditRights")),t=_.first(_.pluck(_.where(re,{clientUID:x}),"requestsEditRights")),!0===e&&!1===t&&(Jn.log("$back{PaleGoldenRod}applyUserData: REQUEST_EDITRIGHTS FOR USER -> is false - > event spinner off",e,t,W!==x),ht(),W!==x?(Jn.log("$back{PaleGoldenRod}applyUserData: YOUR REQUEST WAS DECLINED"),U.yell({message:Rn("Your request for edit rights has been declined.")})):ve=_.now()),F.trigger("docs:users:selection",re))}))},{contextMsg:"EditApplication.applyUserData"});function Rt(){f&&0<Be.length&&!L.isProcessingActions()&&!function e(t){Dt(t,!0).done(function(){Be.shift(),0<Be.length&&e(Be[0])})}(Be[0])}function At(e,t,n){if(n&&Kn.info("$badge{EditApp} setServerOSN: Coming back to set OSN from ACK triggered by operations:after event. Current server OSN: "+Ue+" Planned new OSN from ACK: "+e),Ue<e)if(t){if($e=e,f&&L.isProcessingExternalOperations())return Kn.info("$badge{EditApp} setServerOSN: External operations are currently applied -> coming back later. Keeping OSN: "+Ue+". NOT setting OSN from ACK: "+e),void L.one("operations:after",function(){At(e,t,!0)});e===Ue+1?(Ue=e,ke=-1):(ke=e,Kn.info("$badge{EditApp} setServerOSN: Saving OSN from ack temporarily: "+ke))}else Ue+1<e&&Kn.info("$badge{EditApp} setServerOSN: Setting server OSN. Info: Increasing OSN by more than 1. Increasing from: "+Ue+" to "+e),n=Ue,(Ue=e)+1<ke&&Kn.info("$badge{EditApp} setServerOSN: Far distance ACK: ACK OSN is: "+ke+". But received external operations with OSN: "+Ue),ke===Ue+1?(Kn.info("$badge{EditApp} setServerOSN: Updating server OSN with saved ack osn: "+ke+". Triggering event: docs:ackosn:updated after next operations:after."),Ue=ke,ke=-1,L.one("operations:after",function(){Kn.info("$badge{EditApp} setServerOSN: Updating server OSN with saved ack osn: "+ke+". Triggering event: docs:ackosn:updated."),F.trigger("docs:ackosn:updated")})):0<=ke&&ke<Ue&&(Kn.error("$badge{EditApp} setServerOSN: ERROR: Setting server OSN. Receiving OSN from external operation: "+e+". But still have temporary OSN from acknowledge: "+ke),Kn.error("$badge{EditApp} setServerOSN: ERROR: Current locally used server OSN is: "+n),ke=-1,F.trigger("docs:ackosn:updated"));else Kn.info("$badge{EditApp} setServerOSN: Setting server OSN. Avoiding to set server OSN to: "+e+". Current OSN is already: "+Ue);Kn.info("$badge{EditApp} setServerOSN: Setting server OSN to: "+Ue),L.trigger("change:osn",Ue)}function Dt(e,t){if(G)return mn.error("$badge{EditApp} applyRemoteOperations: failed due to internal error"),$.Deferred().reject();var n=f?Dn(e.docStatus,"serverOSN",-1):0;if(n<0)return kn.error("$badge{EditApp} applyRemoteActions: missing server OSN in external operations"),$.Deferred().reject();var r=or(e);if(0===r.length)return f&&At(n),$.when();if(_n.handleMinifiedActions([{operations:r}],!0),f||L.undoManager.clearUndoActions(),mn.log("$badge{EditApp} applyRemoteOperations: last remote operation: "+JSON.stringify(_.last(r))),f){if(L.isProcessingInternalOperations()||0<Be.length&&!t)return t||Be.push(e),F.createResolvedPromise({cached:!0});if(Kn.info("$badge{EditApp} applyRemoteOperations: received external operations with server OSN "+n),At(n),0<Le.length)try{Me+=r.length,r=F.otManager.transformOperations(r,Le)}catch(e){return"OTError"===e.name?(u=[],pt(new an(cn.ERROR_CLIENT_OT_UNRESOLVABLE_OP_CONFLICT_ERROR))):Kn.exception(e,"$badge{EditApp} applyRemoteOperations: operation transformation failed"),$.Deferred().reject({cause:"operation"})}else Kn.trace("$badge{EditApp} applyRemoteOperations: external operations not transformed:",r)}n=L.applyExternalOperations(r);return n.done(function(){D=!0}),n.fail(function(){F&&!F.isInQuit()&&mn.error("$badge{EditApp} applyRemoteOperations: failed")}),n}var vt=this.synchronize(function(o){if(function(e){if(!f){var t=!1,n=L.getOperationStateNumber();return On.RESTORE_DOCUMENT_ENABLED&&0<e.length&&(t=!("editSync"!==ce||!Ht()||!P.hasPendingActions())||n!==e[0].osn),t}}(or(o)))return f?F.setInternalError(cn.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,sn.CONNECTION):ce||It()?F.restoreDocument(new an(cn.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)):F.setInternalError(cn.ERROR_GENERAL_SYNCHRONIZATION_ERROR,sn.CONNECTION),$.when();var e=Dt(o);return e.done(function(e){var t,n,r,i;_.isObject(o)&&!_.isObject(o.docStatus)&&kn.error("$badge{EditApp} broadcast_update sent bad data "+JSON.stringify(o)),f&&e&&e.cached||(_t(o.docStatus),t=o,n=F.getFileDescriptor(),r=tn.getStringOption(t,"fileName",""),i=tn.getStringOption(t,"com.openexchange.file.sanitizedFilename",""),e=tn.getStringOption(t,"fileVersion",""),t={},0<r.length&&r!==tn.getStringOption(n,"filename")&&(t.filename=r),0<i.length&&i!==tn.getStringOption(n,"com.openexchange.file.sanitizedFilename")&&(t["com.openexchange.file.sanitizedFilename"]=i),0<e.length&&e!==tn.getStringOption(n,"version")&&(t.version=e),G||_.isEmpty(t)||(F.updateFileDescriptor(t),F.getController().update(),ze()))}),e},{contextMsg:"EditApplication.applyUpdateMessageData"});function yt(e){if(!_.isObject(e))return kn.error("$badge{EditApp} registerUpdateMessageData: invalid response (object expected):",e),this.setInternalError(cn.ERROR_WHILE_MODIFYING_DOCUMENT,sn.GENERAL),$.Deferred().reject();var t;mn.log("$badge{EditApp} registerUpdateMessageData: received update message:",e),0<ie.length&&x!==e.editUserId&&(mn.log(" "+ie.length+' existing pending updates must be changed to user "'+e.editUserId+'"'),t={editUser:e.editUser,editUserId:e.editUserId},ie.forEach(function(e){_.extend(e,t)})),ie.push(e);e=vt(e);return e.always(function(){ie.shift(),mn.log("$badge{EditApp} registerUpdateMessageData: update processed, "+ie.length+" pending messages left")}),e}function Ct(e,t,n){if(!e)return yn();e=(e=bn(e.bind(F)).fail(function(){kn.warn("$badge{EditApp} failed initialization step: "+n)})).then(function(e){return F.isInQuit()?Cn({cause:"closing"}):e});return F.launchTracker.asyncStep(e,t,"$badge{EditApp} "+n)}function bt(e){if(_.isObject(F)&&!F.isInQuit()||(e={cause:"quit"}),ue)return{cause:""};var t,n,r=new an(e),i=r.getCodeAsConstant();return G=!0,s.call(F,e),e=_.clone(e),"GENERAL_FILE_NOT_FOUND_ERROR"===i&&(C=!0),r.isError()||((n=e)&&n.error_desc&&n.error_id&&_.isString(n.error_desc)&&_.isString(n.error_id)?(t=e,r=new an(an.GENERAL_ERROR),t&&t.error_desc&&(t=t.error_desc,r.setDescription(t))):r=new an(cn.ERROR_UNKNOWN_REALTIME_FAILURE)),F.isInQuit()||F.setInternalError(r,sn.LOAD,null,{showMessage:!1}),e=_.extend({},e,{errorForErrorCode:F.isViewerMode()}),ue=!0,e}function Tt(e,t){e={operations:e||[]};return t&&(e.userData=t),e}function wt(){return i&&i.operations&&0<i.operations.length}function Ft(){return r||0<u.length||wt()}function Lt(t){Ln(Le,function(e){return!e[t]})}var Ut,xt,kt=(Ut=null,function(){if(mn.log("$badge{EditApp} sendActions: entered"),r)return mn.log("$badge{EditApp} sendActions: sending in progress - using current promise"),Ut.promise();if(G)return mn.error("$badge{EditApp} sendActions: internal error detected - promise rejected!"),$.Deferred().reject();if(f&&(Ln(u,function(e){return 0<e.operations.length}),Ln(Le,function(e){return 0<e.operations.length})),0===u.length)return mn.log("$badge{EditApp} sendActions: no need to send action buffer empty"),$.when();if(f){if(0<=ke)return Kn.info("$badge{EditApp} sendActions: Not all external operations are currently applied. Coming back later, when all external ops are applied!"),F.once("docs:ackosn:updated",Qt),Ut.promise();if(L.isProcessingExternalOperations())return Kn.info("$badge{EditApp} sendActions: External operations are currently applied. Coming back later in operations:after handler!"),L.one("operations:after",Kt),Ut.promise()}return Ut=F.createDeferred("EditApplication.sendActions").always(function(){mn.log("$badge{EditApp} sendActions: current send promise resolved - sendingActions = false"),r=!1,a=_.now(),ze()}),r=!0,ze(),function t(){if(On.REALTIME_DEBUGGING&&Y&&u&&0<u.length&&(e=u[u.length-1].operations)&&0<e.length&&kn.log("$badge{EditApp} sendActionsBuffer: last action:",_.last(e)),f&&Fe)return F.executeDelayed(function(){t()},"sendActionsBuffer",1e3),void Ut.resolve();l&&d&&(n=f?u.length:0,u=l.call(F,u),f&&u.length!==n&&Lt("_OPTIMIZED_OPERATION_")),Qn("$badge{EditApp} sendActions: sending local actions, serverOSN="+Ue,u),u=_n.handleMinifiedActions(u),f&&Le.forEach(function(e){e.sentToServer=!0});var e=u.map(function(e){return{operations:e.operations}}),n=f?Ue:void 0,n=Ht()?P.sendActions(e,n):F.createRejectedPromise();n.done(function(e){f&&(Kn.info("$badge{EditApp} sendActions: Receiving acknowledge with new OSN sent from server: "+e.body.serverOSN),At(e.body.serverOSN,!0),Kn.info("$badge{EditApp} sendActions: Trying to clear local operation cache after receiving acknowledge"),zt()),G?(mn.error("$badge{EditApp} sendActionsBuffer: sent successfully, but internal error detected!"),Ut.reject()):0===u.length?Ut.resolve():f&&L.isProcessingExternalOperations()?(Kn.info("$badge{EditApp} sendActions: External operations are currently applied. Calling sendActions later in operations:after handler!"),L.one("operations:after",Kt),Ut.resolve()):f&&0<ke?(Kn.info("$badge{EditApp} sendActions: External operations are still missing. Calling sendActions later in operations:after handler!"),L.one("operations:after",Kt),Ut.resolve()):t()}),n.fail(function(e){mn.error("$badge{EditApp} sendActionsBuffer: rtConnection.sendActions promise failed!"),Pe=!0,Ut.reject(e)}),u=[]}(),Ut.promise()}),$t=(xt=F.debounce(function(t){var e=!1;mn.log(function(){var e=0<t.operations.length?JSON.stringify(_.last(t.operations)):null;return"$badge{EditApp} storeAction: "+(e?"last operation: "+e:"no operations provided")}),p&&0<_e.length&&(u=p.call(F,u,_e),_e=[],e=!(p=null)),!G&&(0<t.operations.length||e)&&(0<t.operations.length&&(u.push(t),f&&(Le.push(t),Qn("$badge{EditApp} registerAction: added local action without ACK to cache",Le))),o=A=!0,ze())},kt,{delay:E,maxDelay:E,contextMsg:"EditApplication.storeAndSendDebounced"}),function(e){he?xt(e):(mn.log("$badge{EditApp} registerAction: cached action during non-distribution mode"),_e.push(e))});function Pt(t){var e=U.processUnsavedComment(t===Vn.QUIT);return e=(e=(e=e.then(function(){return v})).then(function(){var e=w&&w.prepareFlushHandler;return e?e.call(F,t):null})).then(function(){var e=kt();return t===Vn.QUIT&&(e=sr(e,5e3,"EditApplication.prepareFlushDocument")),e})}var Mt,Bt=_.once(function(){if(Ve=!0,Ht())try{var e=w&&w.prepareLeaveDataHandler,t=e?e.call(F):null}finally{P.emergencyLeave(t)}Ke(!1)});function Ht(){return!(!P||P.destroyed)}function Gt(){P&&(ht(),Ot(),P.destroy(),F.rtConnection=P=null)}function qt(e,t,n){if(Ve||!Ht())return Cn();var r=null,i=P.getConnectOpenState();if(mn.log("$badge{EditApp} executeShutdownStep: - silentShutdownEntered:",jt()," connectionOpenState:",i," action:",e),!jt()){var o=!1,a=!1,s=!1;switch(i){case"unknown":case"joining":s=a=o=!1;break;case"joined":s=!(a=o=!1);break;case"opening":s=!(a=!(o=!0));break;case"opened":s=a=!(o=!1)}r=function(){switch(e){case".abortOpen":return o?P.abortOpen():null;case".closeDocument":return a?P.closeDocument(t):null;case".disconnect":return s?P.disconnect(t):null}}()}return jt()&&(r=function(){switch(e){case".closeDocument:force":return P.closeDocument(t);case".disconnect:force":return P.disconnect(t)}}()),r?n?sr(r,n,'EditApplication.executeShutdownStep("'+e+'")'):r:Cn()}function jt(){return!(null===be)}function Vt(e){var n,r,i=tn.getBooleanOption(e,"skipCloseDoc",!1),o=tn.getBooleanOption(e,"skipDisconnect",!1);mn.log("$badge{EditApp} silentShutdownConnection entered! - silentShutdownConfig:",e,"silentShutdownConnectionEntered",jt()),jt()||(Ke(!(H=!0)),f&&xe.abort(),n=$.Deferred(),be=n.promise(),Ht()&&P.off(),(r=i?$.when():qt(".closeDocument:force",{no_restore:ye},500)).always(function(e){var t=o?$.when():(e="timeout"===e,t="rejected"===r.state(),t=e||Boolean(i)||t,mn.log("$badge{EditApp} silentShutdownConnection: closeDocument rejected by timeout?:",e),qt(".disconnect:force",t,500));t.always(function(){Gt(),mn.log("$badge{EditApp} silentShutdownConnection is finished"),n.resolve()})}))}function Wt(c,e){var d=F.getWindow();function t(e){var t,n,r,i,o=F.createDeferred("EditApplication.checkCloseDocumentResult"),a=new an(e),s={},l=null;return a.isError()||a.isWarning()?(t=tn.getStringOption(e,ln.RESTORED_FILEID,null),n=tn.getStringOption(e,ln.RESTORED_FILENAME,null),r=tn.getStringOption(e,ln.RESTORED_FOLDERID,null),l=tn.getStringOption(e,ln.RESTORED_ERRORCODE,"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"),_.isString(t)&&_.isString(n)&&_.isString(r)?(l=l===an.CONSTANT_NO_ERROR?new an({errorClass:an.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"}):new an({errorClass:an.ERRORCLASS_ERROR,error:l}),s[ln.RESTORED_FILENAME]=n,on.getPath(r).always(function(e){s[ln.RESTORED_PATHNAME]=on.preparePath(e),s[ln.ORIGINAL_FILEID]=F.getFileDescriptor().id,F.updateFileDescriptor({id:t,folder_id:r}),F.setInternalError(l,sn.CLOSE,a,{additionalData:s})})):F.setInternalError(a,sn.CLOSE,null,{additionalData:s}),L&&U?(F.registerQuitHandler(function(){o.reject()}),F.quit=(i=F.quit,function(){return o.reject(),i.call(F)}),d.idle(),o.always(function(){d.busy()}),c===Wn.LOGOUT&&o.reject()):o.reject(),a.getDescription()&&kn.log(a.getDescription()),o.promise()):e}return qt(".closeDocument",e=e||null,8e3).then(t,function(e){return"timeout"===e?F.createRejectedPromise(e):t(e)})}function Yt(){Kn.info("$badge{EditApp} clearLocalActionsWithoutAckAfterEvent: Clearing the local actions!"),zt()}function zt(){L.isProcessingExternalOperations()?(L.off("operations:after",Yt),Kn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are currently applied. Coming back later after event operations:after!"),L.on("operations:after",Yt)):0<ke?(F.off("docs:ackosn:updated",Yt),L.off("operations:after",Yt),Kn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are still missing. Coming back later after event docs:ackosn:updated or operations:after!"),F.on("docs:ackosn:updated",Yt),L.on("operations:after",Yt)):(Kn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. Before: "+JSON.stringify(Le)),L.off("operations:after",Yt),F.off("docs:ackosn:updated",Yt),Lt("sentToServer"),Kn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. After: "+JSON.stringify(Le)))}function Kt(){Kn.info("$badge{EditApp} sendActionsAfterApplyingExternalOperations: Sending actions after receiving operations:after event!"),kt()}function Qt(){Kn.info("$badge{EditApp} sendActionsAfterReceivingRequiredExternalOperations: Sending actions after receiving docs:ackosn:updated event!"),kt()}function Zt(){F.isOnline()&&rn.isTabVisible()&&xe.start()}this.leaveBusyDuringImport=_.once(function(e,t){return oe=F.launchTracker.step("previewStart","$badge{EditApp} Busy state during import process left"),ze(),U.showAfterImport(e,t)}),this.createDebouncedFor=function(t,e,n,r){var i=!1;return t.debounce(e,function(){if(!i){if(!F.isImportFinished()||!L.isProcessingActions())return n.call(t);var e=L.waitForActionsProcessed();i=!0,t.await(e,function(){i=!1,n.call(t)})}},r)},this.checkStartOfExternalOperations=function(){!f||i||L.isProcessingInternalOperations()||F.trigger("docs:operations:completed")},this.isRemovalOfInternalBlockerPossible=function(){return f&&!i&&!L.isDrawingChangeActive()},this.getFileFormat=function(){var e;return null===n&&(e=this.hasFileDescriptor()?this.getFullFileName():T&&T.templateFile?T.templateFile.filename:"",n=e?fn.getFileFormat(e):null),n||"ooxml"},this.isOOXML=function(){return"ooxml"===this.getFileFormat()},this.isODF=function(){return"odf"===this.getFileFormat()},this.isTemplateFile=function(){return this.hasFileDescriptor()&&fn.isTemplate(this.getFullFileName())},this.isScriptable=function(){return this.hasFileDescriptor()&&fn.isScriptable(this.getFullFileName())},this.isShutdownReceived=function(){return!1},this.getClientId=function(){return x},this.getShortClientId=function(){return x.slice(0,4)},this.getDocUID=function(){return Ht()?P.getDocUID():null},this.getLoadMode=function(){return we},this.getEditClientId=function(){return W},this.getEditClientUserName=function(){return Xe(W)},this.getClientOperationName=function(){return k},this.getActiveClients=function(){return re},this.isLocallyModified=function(){return A},this.isPrepareLosingEditRights=function(){return Y},this.sendActionRequest=function(t,n,r){if(!Ht())return F.createRejectedPromise();var e={action:t,docuid:P.getDocUID(),requestdata:JSON.stringify(n)};r=_.extend({method:"POST"},r);e=this.sendFileRequest(Un,e,r);return e.fail(function(e){kn.warn("$badge{EditApp} sendActionRequest: failed: ",t,n,r,e)}),e},this.sendAddImageIdRequest=function(e){return Ht()?P.addImageId(e).then(_.constant(e)):yn(e)},this.sendLogMessage=On.LOG_ERROR_DATA?function(e){return F&&F.allowStoreLogFile()&&F.sendLogErrorData({errorCode:e}),this}:tn.NOOP,this.sendCommentNotification=function(e,t,n){var r=F.getFileDescriptor(),r={recipients:e&&e.map(function(e){return{userId:_n.resolveUserId(Number(e.userId.split("::")[1])),emailAddress:e.email,posInComment:e.pos,lengthInComment:e.length}}),comment:t,commentId:n,filename:r.filename,fileId:r.id,folderId:r.folder_id},r={action:"sendcommentnotification",requestdata:JSON.stringify(r)};return F.sendRequest(Un,r,{method:"POST"})},this.isRenameEnabled=function(){return!Bn&&(!Z&&!On.getDebugFlag("office:simple-filestore")||!this.isDocumentEncrypted()&&!f)},this.rename=function(e){var t=this.getFileDescriptor(),n=tn.getStringOption(t,"filename",this.getFullFileName()),r=tn.getStringOption(t,"com.openexchange.file.sanitizedFilename",n),i=wn(e);if(this.setUnsavedFileName(null),v)return kn.warn("$badge{EditApp} rename: multiple calls, ignoring subsequent call"),v;if(0===i.length)return $.Deferred().reject();if(i===this.getShortFileName())return $.when();i+="."+this.getFileExtension(),this.isDocumentEncrypted()&&(i+=on.GUARD_EXT),this.updateFileDescriptor({filename:i}),Se=this.createDeferred("EditApplication.renameAndReload",{background:!0});e=w&&w.prepareRenameHandler;return(v=(v=(v=(v=e?bn(e.bind(F)):yn()).then(kt)).then(function(){return Ht()?P.renameDocument({target_filename:i}):Cn()})).then(function(e){var t=new an(e);return t.isWarning()&&"RENAMEDOCUMENT_SAVE_IN_PROGRESS_WARNING"===t.getCodeAsConstant()?Se.promise():t.isError()?Cn(t):e})).done(function(e){y=!0,F.updateFileDescriptor({filename:tn.getStringOption(e,"fileName",n),"com.openexchange.file.sanitizedFilename":tn.getStringOption(e,"com.openexchange.file.sanitizedFilename",r)})}),v.fail(function(e){var t;"abort"!==e&&((t=an.isErrorCode(e)?e:new an(e)).setErrorContext(sn.RENAME),(e=un.getMessageData(t)).restoreHidden=!1,kn.warn("$badge{EditApp} rename: error: "+t.getErrorText()),U.yell(e)),F.updateFileDescriptor({filename:n})}),v.always(function(){v=null})},this.getCurrentFileName=function(){return v?U.getToolbarFileNameFieldValue():F.getShortFileName()},this.hasUnsavedChangesOffice=function(){return Ft()||!!v||this.hasUnsavedFileName()||!!L&&L.hasUnsavedComments()||Pe},this.hasUnsavedChanges=function(){return(!ox.tabHandlingEnabled||en.getLoggingOutState()!==en.LOGGING_OUT_STATE.FOLLOWER)&&(!(!Ht()||!P.isConnected())&&(this.hasUnsavedChangesOffice()||P.hasPendingActions()))},this.setUserState=function(e){return this.isInternalError()||m===e||(m=e,Ye()),this},this.getState=function(){return m&&!this.isInternalError()?m:S},this.isEditable=function(){return R},this.isOnline=function(){return"offline"!==S},this.isInternalError=function(){return"error"===S},this.setInternalError=function(e,t,n,r){var i=an.isErrorCode(e)?e:new an(e),o=null,a=null,s=null,l=!0,c=tn.getObjectOption(r,"additionalData",{}),d=an.isErrorCode(n)?n:i,u=!1,g=tn.getObjectOption(r,"silentShutdownConfig",{}),e=tn.getBooleanOption(r,"hideError",!1),n=i.isError();if(F.isReloading()&&F.setAppReloadDone(F),_.isString(t)&&i.setErrorContext(t),o=F.getErrorState(),(t=!_.isObject(o)||!o.isError())?(F.setErrorState(i),u=!0):_.isObject(o)&&(i=o,a=Ce),s=F.getErrorState(),an.isErrorCode(s)&&!e&&kn.error("$badge{EditApp} setInternalError: "+s.getErrorText()),n?(Ke(!(H=!(I=!(G=!0)))),Vt(g)):(s=_.has(ge,i.getCodeAsConstant()),g=pe===i.getCodeAsConstant()&&un.suppressDirectlyRepeated(i.getCodeAsConstant()),l=!s&&!g,un.showOnceInDocLifetime(i.getCodeAsConstant())&&(ge[i.getCodeAsConstant()]=!0),pe=i.getCodeAsConstant()),ze(i),_.isObject(a)&&!u||(a=un.getMessageData(i,_.extend({causeError:d,viewerMode:F.isViewerMode()},Qe(),c)),F.extendMessageData(a),Ne="document/reload"===tn.getStringOption(a.action,"itemKey"),Ce=a),tn.getBooleanOption(r,"showMessage",!0)&&l&&F.waitForImport(function(){U&&U.yell&&U.yell(a)}),n&&t&&!Ve){try{q=F.sendLogErrorData({errorCode:i.getCodeAsConstant()})}catch(e){kn.error("$badge{EditApp} Error when sendLogErrorData is callend in setInternalError error:",e," fileDec:",F&&_.isFunction(F.getFileDescriptor)&&F.getFileDescriptor())}if(F.allowStoreLogFile()&&un.createCrashDataForError(i.getCodeAsConstant()))if(on.isGuest())F.createCrashDataAsDownload();else try{F.createCrashDataInDrive()}catch(e){kn.error("$badge{EditApp} Error when createCrashDataInDrive is callend in setInternalError error:",e," fileDec:",F&&_.isFunction(F.getFileDescriptor)&&F.getFileDescriptor())}}},this.createCrashDataAsDownload=function(){var e,t,n;this.generateLogData()&&(n=Rn("A debug report can be downloaded. The report may contain content of previously opened documents."),e=new jn(n,{title:Rn("Generating debug report"),classes:"generate-log-dialog",okLabel:Nn.CLOSE_LABEL,showReadOnly:!0}),t=$('<div style="padding: 10px 0; text-align: center; font-weight: 400; font-size: 14px" class="result"></div>'),n=$('<a href="#"><i class="fa fa-download" aria-hidden="true"></i><span style="padding: 0px 10px"<span>Download</span></a>'),e.listenTo(n,"click",function(){F.downloadFrontendLog()}),t.append(n),e.append(t),e.show())},this.createCrashDataInDrive=function(){var e,t,n,r,i=this.generateLogData();i&&(e=Rn("A debug report is uploaded to Drive/myFiles/crashdata. This can take a while. Closing the browser tab cancels the upload. The report may contain content of previously opened documents."),e=new jn(e,{title:Rn("Generating debug report"),classes:"generate-log-dialog",okLabel:Nn.CLOSE_LABEL,showReadOnly:!0}),t=Rn("Finished upload"),n=Rn("Could not upload file"),r=$('<div style="padding: 10px 0; text-align: center; font-weight: 400; font-size: 14px" class="result"><div class="busy-indicator io-ox-busy"></div></div>'),e.append(r),e.show(),this.sendLogErrorData({logData:i}).done(function(){r.html('<i class="fa fa-check" aria-hidden="true"></i><span style="padding: 0px 5px">'+t+"</span>")}).fail(function(){r.html('<i class="fa fa-exclamation-circle" aria-hidden="true"></i><span style="padding: 0px 5px">'+n+"</span>")}))},this.allowStoreLogFile=function(){return On.LOG_ERROR_DATA&&!!F&&!F.isDocumentEncrypted()},this.sendLogErrorData=function(e){var t=_.has(e,"errorCode"),n=_.has(e,"logData");if(!t&&!n)return F.createRejectedPromise();function r(e){return a?"hidden":e}var i,o,a=!On.LOG_ERROR_DATA,s=F.getFileDescriptor(),n={action:"logclientdata",logAnonymous:String(a),fileId:String(r(s&&s.id)),folderId:String(r(s&&s.folder_id)),fileName:String(r(F.getFullFileName())),userId:String(ox&&ox.user_id),docUid:String(Ge),errorCode:t?(o=e&&e.errorCode,String(o||"unknownError")):"",logData:n&&F.allowStoreLogFile()?(i=e&&e.logData,String(i)):""};return F.sendRequest(Un,n,{method:"POST",dataType:"xml"})},this.setCurrentInfoState=function(e,t){var n,r=tn.getBooleanOption(t,"showMessage",!0),i=null;return tn.getBooleanOption(t,"resetWarning",!1)&&(i=F.getErrorState(),_.isObject(i)&&i.isError()||F.setErrorState(new an)),F.setInfoState(e),!(!r||(n=gn.getMessageData(e,_.extend({},Qe(),t)),F.extendMessageData(n),!_.isObject(n)))&&U.yell(n)},this.isLocked=function(){return G||H},this.isAcquireEditRightsEnabled=function(){return!f&&Ht()&&!this.isLocked()&&this.isOnline()&&!R},this.isAcquireEditRightsEnabledPendingUpdates=function(){return this.isAcquireEditRightsEnabled()&&ie.length<=1},this.acquireEditRights=function(){if(Jn.log("$back{Orchid}acquireEditRights - User wants to acquireEditRights -> Button pressed  "),this.isAcquireEditRightsEnabled())return Ae.start();ht()},this.saveDocumentAs=function(n,e,r,i){var o=e,a=null,s=F.getFileDescriptor(),t=null,l=!1;switch(r){case Pn.NATIVE:if(i&&i.encrypted){o+="."+F.getFileExtension()+on.GUARD_EXT,t=(t=(t=on.authorizeGuard().then(function(e){T.auth_code=e},function(){return l=!0,Cn()})).then(function(){return F.flushDocument(Vn.DOWNLOAD)})).then(function(){var e=s.file_options||{},t=e.params||{};return _.extend(t,{cryptoAction:"Encrypt",filedisplay:o,ignoreWarnings:!1}),s.file_options=_.extend(e,{params:t}),on.copyFile(s,n)});break}case Pn.TEMPLATE:o+="."+F.getFileExtension(),t=(t=F.flushDocument(Vn.DOWNLOAD)).then(function(){return Ht()?P.copyDocument({file_id:F.getFileParameters().id,target_filename:e,asTemplate:r===Pn.TEMPLATE,target_folder_id:n}):Cn()});break;case Pn.PDF:o+=".pdf",t=(t=(t=F.flushDocument(Vn.DOWNLOAD)).then(function(){return on.propagateChangeFile(s)})).then(function(){return on.getFileModelFromDescriptor(s).then(function(e){return Jt.sendConverterRequest(e,{documentformat:"pdf",saveas_filename:o,saveas_folder_id:n})})});break;default:return kn.error('$badge{EditApp} saveDocumentAs: unknown file type "'+r+'"'),Cn()}return(t=(t=(t=t.then(function(e){var t=new an(e);return t.isError()?Cn(t):e})).then(function(t){return o=tn.getStringOption(t,"filename")||o,on.deleteFromCache(n),on.getPath(n).then(function(e){return a=on.preparePath(e),t})})).then(function(e){if(r!==Pn.PDF){r===Pn.TEMPLATE&&F.setCurrentInfoState(dn.INFO_DOC_SAVED_AS_TEMPLATE,{fullFileName:o,fullPathName:a,type:"success",duration:1e4});var t=tn.getStringOption(e,"id",null);return!t&&i&&i.encrypted&&(t=_.isArray(e)?tn.getStringOption(_.first(e),"data",null):e),n=n||tn.getStringOption(e,"folder_id",null),on.getFile({id:t,folder_id:n}).then(function(e){e.title=on.getFileBaseName(e.filename),F.updateFileDescriptor(e),T.action="load",delete T.template,F.reloadDocument();e=F.newDeferred("EditApplication.saveDocumentAs.keepBusyScreenOpen");return F.createAbortablePromise(e)})}F.setCurrentInfoState(dn.INFO_DOC_SAVED_IN_FOLDER,{fullFileName:o,fullPathName:a,type:"success",duration:1e4})})).fail(function(e){"destroy"!==e&&("cancel"===e||l||(Jt.isDocConverterError(e)?U.yell({type:"error",message:Jt.getErrorTextFromResponse(e)}):((e=an.isErrorCode(e)?e:new an(an.GENERAL_ERROR)).setErrorContext(sn.SAVEAS),kn.warn('$badge{EditApp} saveDocumentAs: Error code "'+e.getCodeAsConstant()+'"'),U.yell(un.getMessageData(e,Qe())))))}),t},this.isReloadEnabled=function(){return Ne},this.reloadDocument=function(e,t){this.trigger("docs:reload:prepare");var n=this.getFileDescriptor(),r=this.getFullFileName(),i=fn.getEditModule(r);if(!i)return kn.error("$badge{EditApp} reloadDocument: unknown application type"),Cn();if(!fn.isNative(r))return kn.error("$badge{EditApp} reloadDocument: unsupported document type"),Cn();e=_.extend({},e,{action:"load",file:n}),T.auth_code&&(e.auth_code=T.auth_code),e.activeTabId=U.toolBarTabs.getActiveTabId(),e.commentsPaneVisible=U.commentsPane&&U.commentsPane.isVisible();n=w&&w.prepareReloadHandler;return n&&_.extend(e,n.call(this)),U.isBusy()||t||U.enterBusy(),kn.info("$badge{EditApp} reloadDocument: start reloading the document",e),this.quit(Wn.RELOAD,{editModule:i+"/main",reloadLaunchOptions:e})},this.restoreDocument=function(l,e){var t,n,r=tn.getArrayOption(e,"actions",null),i=F.getFileDescriptor(),o=null;On.RESTORE_DOCUMENT_ENABLED?Ie||(ye=!(Ie=!0),o=_.isNull(r)?(e=_n.handleMinifiedActions(u),Ht()?(t=P.getPendingActions(),n=e,t=_n.getActionsArray(t),n=_n.getActionsArray(n),_.isArray(t)&&_.isArray(n)?t.concat(n):t):e):r,Ke(!(H=!0)),ze(),G=!0,o={action:"saveaswithbackup",file_id:i.id,target_filename:i.filename,target_folder_id:i.folder_id,restore_id:me,operations:_.isNull(o)?o:JSON.stringify(o)},F.sendFileRequest(Un,o,{method:"POST"}).then(function(e){var t=new an(e),n=F.newDeferred("EditApplication.restoreDocument"),r=tn.getStringOption(e,ln.RESTORED_FILEID,null),i=tn.getStringOption(e,ln.RESTORED_FILENAME,null),o=tn.getStringOption(e,ln.RESTORED_FOLDERID,null),a=null,s={};_.isObject(e)&&_.isString(i)&&_.isString(o)?on.getPath(o).always(function(e){a=on.preparePath(e),n.resolve(a)}):n.resolve(null),n.always(function(e){e=_.isString(e);t.isError()||(t=new an({errorClass:an.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"})),s[ln.RESTORED_FILENAME]=i,s[ln.RESTORED_PATHNAME]=a,s[ln.ORIGINAL_FILEID]=F.getFileDescriptor().id,e&&F.updateFileDescriptor({id:r,folder_id:o}),F.setInternalError(t,l.getErrorContext(),l,{additionalData:s})})},function(){F.setInternalError(l)})):F.setInternalError(l)},this.rejectEditAttempt=function(e){if(this.isViewerMode())return!1;switch(e){case"image":return U.yell({message:Rn("The image could not be inserted.")});case"siri":return this.setInternalError(cn.ERROR_SIRI_NOT_SUPPORTED,sn.GENERAL),!0;case"loadingInProgress":return this.setCurrentInfoState(dn.INFO_LOADING_IN_PROGRESS);default:return this.isImportFinished()?Ze():this.setCurrentInfoState(dn.INFO_LOADING_IN_PROGRESS)}},this.getUserInfo=function(e){return this.createResolvedPromise().then(function(){return Xt.get({id:e})}).then(function(e){var t=!!e.guest_created_by,n=_.noI18n(e.display_name||e.email1||""),r=t?"User "+e.user_id:e.first_name&&e.last_name?_.noI18n(e.first_name.trim()+" "+e.last_name.trim()):e.last_name?_.noI18n(e.last_name.trim()):e.first_name?_.noI18n(e.first_name.trim()):n;return{id:e.user_id,displayName:n,operationName:r,guest:t}})},this.updateUserData=(Mt=null,F.debounce(function(e){return Mt=e,this},function(){Ht()&&F.isImportSucceeded()&&!G&&!F.isInQuit()&&P.updateUserData("updateuserdata",Mt)},{delay:500,maxDelay:1e3,contextMsg:"EditApplication.updateUserData"})),this.registerAuthorItem=function(e){var t,n;"authorId"in e&&"authorName"in e&&(t=e.authorId,(n=(_.isFinite(t)||_.isString(t))&&tn.getStringOption(e,"authorName","").trim()||"")&&(fe[t]={id:t,name:n,initials:tn.getStringOption(e,"initials","").trim()||null,providerId:tn.getStringOption(e,"providerId","").trim()||null,userId:tn.getStringOption(e,"userId","").trim()||null}))},this.getRegisteredAuthorItemById=function(e){return fe[e]},this.getAuthorColorIndex=function(e){return nn.getSchemeColor((t=e,(e=_.indexOf(Ee,t))<0&&(e=Ee.length,Ee.push(t)),e));var t},this.addAuthors=function(e){return Ee=_.union(Ee,e),this},this.stopOperationDistribution=function(e){return he=!1,F.convertToPromise(e.call(F)).always(function(){he=!0})},this.isOperationsBlockActive=function(){return Oe},this.enterBlockOperationsMode=function(e){Oe=!0,wt()&&(F.trigger("docs:operations:remove",i.operations.length),i=Tt(null,i.userData)),e.call(F),Oe=!1},this.isMultiSelectionApplication=function(){return h},this.isSnapshotApp=function(){return O},this.isFirstTabActivated=function(){return Re},this.getLoadDocInfo=function(){return He},this.isOTEnabled=function(){return f},Object.defineProperty(this,"otManager",{get:function(){return t=t||e.createOTManager(this.docModel)},configurable:!0,enumerable:!0}),this.transformPositionWithLocalActions=function(e,t){return this.otManager.transformPosition(e,Le,t)},this.getOTStatistics=function(){return{extOpCount:Me,otCount:t?t.getStatistics().otCount:0}},this.setOTBlockingOpsMode=function(e){Fe=e},this.isOTBlockingOpsMode=function(){return Fe},this.hasLocalActionsWithoutAck=function(){return f&&0<Le.length},this.getServerOSN=function(){return Ue},this.isRescueDocument=function(){return je},this.isRescueDocMode=function(){return On.DEBUG&&je},this.generateLogData=function(){var e=$n();if(0===e.length)return"";var t=navigator.userAgent,n=Ge,r=qe,i=this.getFullFileName(),o=on.isGuest();return t+"\ndoc_uid: "+n+"\nclient_uid: "+r+"\napp: "+this.appType+"\nguestUser: "+o+"\nfileName: "+i+"\n \n"+e.join("\n")},this.downloadFrontendLog=function(){var e="Documents_UI_log_"+ox.user+(new Date).toISOString()+".txt";Yn(e,this.generateLogData())},this.useOperationOptimization=function(e){d=e},this.showEditToolbarAtStart=function(){return F.getUserSettingsValue("showToolbars",!0)||_.device("!desktop")},this.handleSessionChanged=function(){ot()},this.handleSessionInvalidError=function(e){st(e)},this.debugTypeError=On.DEBUG?{testPlace:null,activateTestPlace:function(e){this.testPlace=e},test:function(e){this.testPlace===e&&(kn.info("You should see a typeError now at",e),this.debugxyz.debugTypeErrorXYZ())}}:$.noop,(Ae=new Xn(this)).startHook.on(function(){F.trigger("docs:acquireeditrights:start")}),Ae.finishHook.on(function(){F.trigger("docs:acquireeditrights:end")}),xe=new qn(function(){return Ht()?P.syncStable().catch(_.noop):yn()},{delay:3e4,interval:3e4,windowId:this.getWindowId(),contextMsg:"EditApplication.osnBeacon",background:!0}),this.onInit(function(){L=this.docModel,U=this.docView,this.getWindow().addClass("io-ox-office-edit-window"),this.waitForImport(function(){ae=F.launchTracker.step("triggerImportSuccess","$badge{EditApp} End of import process notified"),ve=ae,mn.log("Load-mode:",we)}),ze(),et(),tt(),this.listenTo(L,"operations:error",function(){Ke(!1)}),this.listenTo(F,"docs:reload",pt),this.on("docs:operations:completed",Rt),fn.supportsEditMode(F.appType)||(Ke(!(H=!0)),ze(),Ze(fn.DOM_TEXT_EDIT_ALERT,-1)),z&&J&&(kn.info("$badge{EditApp} onInit(): saving document to local storage is active"),Mn?kn.info("$badge{EditApp} onInit: current browser supports local storage"):kn.warn("$badge{EditApp} onInit: current browser does not support local storage")),this.on("docs:flush:success",function(){o=!1}),L.listenTo(rn.hideTabHook,function(){kn.info("Tab hidden, must save?",o),o&&F.flushDocument(Vn.USER),f&&xe.abort()}),L.listenTo(rn.showTabHook,function(){f&&Zt()}),L.listenTo(F.getView(),"view:hide",function(){kn.info("App hidden, must save?",o),o&&F.flushDocument(Vn.USER)})},this),this.registerBeforeUnloadHandler(function(e){e||Bt()}),this.registerUnloadHandler(function(){Bt()}),this.registerBeforeQuitHandler(function(){if(On.DEBUG&&F.debugTypeError.test("sync-beforeQuitHandler"),G)return(q?sr(q,4e3,"EditApplication.waitForInternalErrorLog"):yn()).catch(function(){return yn()});var e=F.isOnline()&&F.hasUnsavedFileName()?F.rename(F.getUnsavedFileName()):yn();return e=(e=e.then(function(){return F.isOnline()?Pt(Vn.QUIT).catch(function(e){if("timeout"===e)return e;throw e}):null})).then(function(){var e=It()&&F.hasUnsavedChangesOffice(),t=Rn("This document contains unsaved changes. Do you really want to close?");return e?U.showQueryDialog(null,t):void 0})}),this.registerQuitHandler(function(e){function t(){return $.when(be).always(function(){mn.log("$badge{EditApp} quitHandler.finalizeRTConnection called"),Gt()})}function n(){try{if(mn.log("$badge{EditApp} quitHandler.connectionGateKeeper entered"),!Ht())return;if(jt())return;var e=P.getCloseLeaveState();switch(mn.log("$badge{EditApp} quitHandler.connectionGateKeeper - connectionOpenState:",e),e){case"unknown":return void Vt();case"closing":case"closed":return void Vt({skipCloseDoc:!0});case"disconnecting":case"disconnected":return;default:return void Vt()}}catch(e){Vt(),kn.warn("$badge{EditApp} quitHandler.connectionGateKeeper: Error caught:",e)}}var r=null;try{mn.log("$badge{EditApp} quitHandler: reason",e),On.DEBUG&&F.debugTypeError.test("sync-quithandler"),r=e===Wn.RELOAD?(Vt(),$.when()):function(e){var t=null,n=F.getWindow(),r=F.getFileDescriptor(),o=!1,i=null,a=["_OSN","_FILEVERSION","_STORAGEVERSION","_OPERATIONS"],E=e===Wn.LOGOUT,s=F.launchTracker;function l(e){o&&U.updateBusyProgress(e)}function h(n){var e="appsuiteDocsExpiryDates",r=localStorage.getItem(e),i=_.now();r&&(r=JSON.parse(r),_.isObject(r)?_.each(r,function(e,t){t!==n&&e<i&&(e=_.pluck(L.getSupportedStorageExtensions({allApps:!0}),"extension").concat(a),_.each(e,function(e){e=t+e;localStorage.removeItem(e)}),delete r[t])}):r=null),(r=r||{})[n]=i+6048e5,localStorage.setItem(e,JSON.stringify(r))}function c(){return on.propagateChangeFile(r)}n&&n.busy();var d=A||y||D||C,n="new"===T.action||T.template;r&&(d||On.LOG_PERFORMANCE_DATA||!n&&ne.length<=1)&&(i={file:_.extend({last_opened:Date.now()},r),app:F.appType},s.setItem("LocalStorage",X),s.setItem("FastEmptyLoad",se),s.sendData());s=Ht()&&P.isConnected()&&!F.isShutdownReceived();t=r&&s?(i=ye?i:_.extend({no_restore:ye},i),(rn.BROWSER_TAB_SUPPORT?Wt(e,i):Wt(e,i).then(function(s){var l,c,d,u,g=null,p=null,e=null,t=A||y||D,n=L.getOperationStateNumber(),f=0,r=20;function i(e){e=tn.getBooleanOption(e,"migration",!1);_.each(a,function(e){localStorage.removeItem(g+e)}),e&&(An(s.syncInfo.fileVersion)?_.each(_.range(s.syncInfo.fileVersion>r?s.syncInfo.fileVersion-r:0,s.syncInfo.fileVersion),function(t){_.each(a,function(e){localStorage.removeItem(g+"_"+t+e)})}):(localStorage.removeItem(g+"_"+s.syncInfo.fileVersion),localStorage.removeItem(g+"_CURRENTVERSION")))}return Je(),(t||!X)&&s&&s.syncInfo&&!E&&!F.isDocumentEncrypted()&&Mn&&z&&J&&_.isFunction(L.getFullModelDescription)&&s.syncInfo.fileVersion&&s.syncInfo.fileId&&s.syncInfo.folderId&&An(s.syncInfo["document-osn"])&&n===s.syncInfo["document-osn"]&&(h(g=s.syncInfo.fileId+"_"+s.syncInfo.folderId),e=F.newDeferred("EditApplication.saveLocalStorage"),F.executeDelayed(function(){o=!0},"EditApplication.saveFileInStorage",1500),F.executeDelayed(function(){e.notify(.1),l=_.now(),L.getFullModelDescription(e,.1,.9).always(function(){_.isFunction(L.getSupportedStorageExtensions)&&_.each(L.getSupportedStorageExtensions(),function(e){e&&_.isString(e.extension)&&a.push(e.extension)}),i({migration:!0})}).done(function(e){function a(e){return i(),kn.info("$badge{EditApp} quitHandler: "+e),!1}e.every(function(e){var t,n,r=e.htmlString,i=g+e.extension;kn.info("$badge{EditApp} quitHandler: created document string with size: "+r.length+". Time for conversion: "+(_.now()-l)+" ms.");try{if(0===f){if(p=g+"_OSN",c=g+"_FILEVERSION",d=g+"_STORAGEVERSION",u=g+"_OPERATIONS",localStorage.setItem(p,s.syncInfo["document-osn"]),localStorage.setItem(d,Q),localStorage.setItem(c,s.syncInfo.fileVersion),t=L.getStorageOperationCollector(),_.each(t,function(e){delete e.osn,delete e.opl}),n=JSON.stringify(t),localStorage.setItem(u,n),!localStorage.getItem(u)||localStorage.getItem(u).length!==n.length)return a("failed to save document operations in local storage");kn.info("$badge{EditApp} quitHandler: successfully saved document operations in local storage with key: "+u)}localStorage.setItem(i,r);var o=localStorage.getItem(i);if(!o||o.length!==r.length)return a("failed to save document in local storage");if(kn.info("$badge{EditApp} quitHandler: successfully saved document in local storage with key: "+i),0===f){o=localStorage.getItem(p),o=o?parseInt(o,10):-1;if(o!==s.syncInfo["document-osn"])return a("failed to save OSN for document in local storage");kn.info("$badge{EditApp} quitHandler: successfully saved OSN for document in local storage with key: "+p+" : "+o)}return f++,!0}catch(e){return a("failed to save document and/or document OSN in local storage")}})}).always(function(){e.notify(1),e.resolve(s)})},"EditApplication.saveFileInStorage")),null===e?s:e.promise()})).progress(l)):$.when();s&&(t=t.then(function(){return On.DEBUG&&F.debugTypeError.test("async-quithandler"),qt(".disconnect",null,2e3)}));r&&(d?t=t.then(c,c):"reload"!==e&&("new"===T.action||T.template)&&ne.length<=1&&!T.keepFile&&(t=t.then(function(){return on.purgeFile(r)})));return t}(e)}catch(e){r=$.when(),kn.warn("$badge{EditApp} quitHander: Error caught:",e)}return r=(r=r.then(n,n)).then(t,t)}),this.waitForImportStart(function(){pn.logState("import","app/loading","pending")}),this.once("docs:state:preview",function(){pn.logState("import","app/preview","pending")}),this.waitForImport(function(){pn.logState("import","app/preview","resolved"),pn.logState("import","app/loading","resolved")}),this.waitForImportSuccess(function(){f&&Zt()}),this.registerDestructor(function(){xe.destroy(),Ae.destroy(),T=w=F=L=U=null,P=u=i=_e=null,M=B=null,c=g=s=null,l=p=null,v=ee=ne=re=null,ie=xe=null,Ae=De=null})})});